#include "StdAfx.h"
#include "testpipe.h"
#include "testpipeDlg.h"
#include "npipe.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CTestpipeDlg, CDialog) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_PAINT()
  ON_WM_QUERYDRAGICON()
  ON_BN_CLICKED(IDC_GETTIME, &CTestpipeDlg::OnGettime)
END_MESSAGE_MAP()

#pragma warning(suppress: 26455)
CTestpipeDlg::CTestpipeDlg(CWnd* pParent) : CDialog{CTestpipeDlg::IDD, pParent},
                                            m_sServer{_T(".")},
                                            m_hIcon{AfxGetApp()->LoadIcon(IDR_MAINFRAME)}
{
}

void CTestpipeDlg::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
  DDX_Text(pDX, IDC_SERVER, m_sServer);
}

BOOL CTestpipeDlg::OnInitDialog()
{
  __super::OnInitDialog();
  SetIcon(m_hIcon, TRUE);
  SetIcon(m_hIcon, FALSE);
  return TRUE;
}

#pragma warning(suppress: 26434)
void CTestpipeDlg::OnPaint()
{
  if (IsIconic())
  {
    CPaintDC dc{this};

#pragma warning(suppress: 26490)
    SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

    //Center icon in client rectangle
    const int cxIcon{GetSystemMetrics(SM_CXICON)};
    const int cyIcon{GetSystemMetrics(SM_CYICON)};
    CRect rect;
    GetClientRect(&rect);
    const int x{(rect.Width() - cxIcon + 1) / 2};
    const int y{(rect.Height() - cyIcon + 1) / 2};

    //Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
    __super::OnPaint();
}

#pragma warning(suppress: 26434)
HCURSOR CTestpipeDlg::OnQueryDragIcon() noexcept
{
#pragma warning(suppress: 26473)
  return static_cast<HCURSOR>(m_hIcon);
}

void CTestpipeDlg::OnGettime()
{
  //Display a wait cursor
  CWaitCursor wc;

  if (!UpdateData(TRUE))
    return;

  //Check the pipe is available
  CString sPipe;
  sPipe.Format(_T("\\\\%s\\PIPE\\TEST_PJTIME"), m_sServer.GetString());
  if (!WaitNamedPipe(sPipe, 1000))
  {
    CString sMsg;
    sMsg.Format(_T("An instance of the specified named pipe is not available to be connected to, Error:%u"), GetLastError());
    AfxMessageBox(sMsg, MB_OK | MB_ICONERROR);
    return;
  }

  //Connect to the pipe
  CNamedPipe clientPipe;
  if (!clientPipe.Open(sPipe, GENERIC_READ | GENERIC_WRITE | FILE_SHARE_READ, 0, nullptr, 0))
  {
    CString sMsg;
    sMsg.Format(_T("Failed to connect to the specified named pipe, Error:%u"), GetLastError());
    AfxMessageBox(sMsg, MB_OK | MB_ICONERROR);
    return;
  }

#ifdef _DEBUG
  ULONG nValue{0};
  BOOL bSuccess{clientPipe.GetServerProcessId(&nValue)};
  UNREFERENCED_PARAMETER(bSuccess);
  UNREFERENCED_PARAMETER(nValue);
  bSuccess = clientPipe.GetServerSessionId(&nValue); //NOLINT(clang-analyzer-deadcode.DeadStores)
#endif //#ifdef _DEBUG

  //Read the time from the server
  SYSTEMTIME st{};
  DWORD dwRead{0};
  if (!clientPipe.Read(&st, sizeof(st), &dwRead))
  {
    CString sMsg;
    sMsg.Format(_T("Failed in call to read from the specified named pipe, Error:%u"), GetLastError());
    AfxMessageBox(sMsg, MB_OK | MB_ICONERROR);
    return;
  }

  //Update the values on the UI
  CString sTime;
  GetTimeFormat(LOCALE_USER_DEFAULT, 0, &st, nullptr, sTime.GetBuffer(256), 256);
  sTime.ReleaseBuffer();
  GetDlgItem(IDC_TIME)->SetWindowText(sTime);

  CString sDate;
  GetDateFormat(LOCALE_USER_DEFAULT, 0, &st, nullptr, sDate.GetBuffer(256), 256);
  sDate.ReleaseBuffer();
  GetDlgItem(IDC_DATE)->SetWindowText(sDate);

  //Close the pipe once were finished with it
  clientPipe.Close();
}
