#include "StdAfx.h"
#include "..\npipe.h"
#include <atlstr.h>


#pragma warning(suppress: 26485)
int _tmain(int /*argc*/, TCHAR* /*argv*/[]) //NOLINT(modernize-avoid-c-arrays)
{
  _tprintf(_T("Time Server demo program has started...\n"));

  //Create the server pipe
  CNamedPipe serverPipe;
  if (!serverPipe.Create(_T("\\\\.\\PIPE\\TEST_PJTIME"), PIPE_ACCESS_DUPLEX, PIPE_TYPE_MESSAGE | PIPE_WAIT, 1, 4096, 4096, 1, nullptr))
  {
    _tprintf(_T("Failed in call to CNamedPipe::Create, Error:%u\n"), GetLastError()); //NOLINT(clang-diagnostic-format)
    return 1;
  }

  while (true)
  {
    //Connect the client
    _tprintf(_T("Waiting for a client to connect\n"));
    if (!serverPipe.Connect())
    {
      _tprintf(_T("Failed in call to CNamedPipe::ConnectClient, Error:%u\n"), GetLastError()); //NOLINT(clang-diagnostic-format)
      return 1;
    }

  #ifdef _DEBUG
    ULONG nValue{0};
    BOOL bSuccess{serverPipe.GetClientProcessId(&nValue)};
    UNREFERENCED_PARAMETER(bSuccess);
    UNREFERENCED_PARAMETER(nValue);
    bSuccess = serverPipe.GetClientSessionId(&nValue); //NOLINT(clang-analyzer-deadcode.DeadStores)
    ATL::CAtlString sClientName;
    bSuccess = serverPipe.GetClientComputerName(sClientName.GetBuffer(_MAX_PATH), _MAX_PATH * sizeof(TCHAR)); //NOLINT(clang-analyzer-deadcode.DeadStores)
    sClientName.ReleaseBuffer();
  #endif //#ifdef _DEBUG

    //Get the current local time
    SYSTEMTIME st{};
    GetLocalTime(&st);

    //Write the time down the socket
    DWORD dwWritten{0};
    if (!serverPipe.Write(&st, sizeof(st), &dwWritten))
    {
      _tprintf(_T("Failed in call to CNamedPipe::Write, Error:%u\n"), GetLastError()); //NOLINT(clang-diagnostic-format)
      return 1;
    }

    //Print some details on what we just did
    ATL::CAtlString sTime;
    GetTimeFormat(LOCALE_USER_DEFAULT, 0, &st, nullptr, sTime.GetBuffer(256), 256);
    sTime.ReleaseBuffer();
    ATL::CAtlString sDate;
    GetDateFormat(LOCALE_USER_DEFAULT, 0, &st, nullptr, sDate.GetBuffer(256), 256);
    sDate.ReleaseBuffer();
    _tprintf(_T("  Sending time %s %s\n"), sDate.GetString(), sTime.GetString());

    //Flush the pipe before we disconnect the client
    serverPipe.Flush();

    //Disconnect the client
    serverPipe.Disconnect();
    _tprintf(_T("  Disconnecting\n"));
  }

  return 0;
}
